package net.takemix.testok;

import java.util.Date;
import java.util.Random;

public class Question {
    static public final Integer MAX_ANSWER = 4;

    public Integer qid;
    public String questionSentence;
    public Integer answerGroup;
    public String[] answer;
    public Integer rightAnswerIndex;
    public Integer selectedIndex;
    public String hint;
    public Integer level;
    public Date date;
    public Long time;
    public Boolean mark;

    public Question() {
        this.answer = new String[MAX_ANSWER];
        this.answerGroup = 0;
        this.rightAnswerIndex = -1;
        this.selectedIndex = -1;
        this.level = 0;
        this.time = (long)0;
    }

    public void random() {
        Random rnd = new Random();

        int rightTemp = this.rightAnswerIndex;
        String answerTemp;
        for (int i = 0; i < MAX_ANSWER; i++) {
            int dest = rnd.nextInt(MAX_ANSWER);
            int src = rnd.nextInt(MAX_ANSWER);

            answerTemp = answer[dest];
            answer[dest] = answer[src];
            answer[src] = answerTemp;

            if (rightTemp == dest) {
                rightTemp = src;
            } else if (rightTemp == src) {
                rightTemp = dest;
            }
        }

        this.rightAnswerIndex = rightTemp;
    }
}
